package cn.meowrain.aioj.backend.upms.biz.service.impl;

import cn.hutool.core.util.ArrayUtil;
import cn.hutool.core.util.StrUtil;
import cn.meowrain.aioj.backend.upms.api.dto.SysLogDTO;
import cn.meowrain.aioj.backend.upms.api.entity.SysLog;
import cn.meowrain.aioj.backend.upms.biz.mapper.SysLogMapper;
import cn.meowrain.aioj.backend.upms.biz.service.SysLogService;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Service
public class SysLogServiceImpl extends ServiceImpl<SysLogMapper, SysLog> implements SysLogService {
    /**
     * 分页查询系统日志
     *
     * @param page   分页参数
     * @param sysLog 日志查询条件
     * @return 分页结果
     */
    @Override
    public Page getLogPage(Page page, SysLogDTO sysLog) {
        return baseMapper.selectPage(page, buildQuery(sysLog));
    }

    /**
     * 保存日志
     *
     * @param sysLog 日志对象
     * @return 保存成功返回true
     */
    @Override
    @Transactional(rollbackFor = Exception.class)
    public Boolean saveLog(SysLog sysLog) {
        baseMapper.insert(sysLog);
        return Boolean.TRUE;
    }

    /**
     * 查询日志列表
     *
     * @param sysLog 查询条件DTO对象
     * @return 日志列表
     */
    @Override
    public List<SysLog> listLogs(SysLogDTO sysLog) {
        return baseMapper.selectList(buildQuery(sysLog));
    }

    /**
     * 构建查询条件
     *
     * @param sysLog 前端查询条件DTO
     * @return 构建好的LambdaQueryWrapper对象
     */
    private LambdaQueryWrapper buildQuery(SysLogDTO sysLog) {
        LambdaQueryWrapper<SysLog> wrapper = Wrappers.lambdaQuery();
        if (StrUtil.isNotBlank(sysLog.getLogType())) {
            wrapper.eq(SysLog::getLogType, sysLog.getLogType());
        }

        if (ArrayUtil.isNotEmpty(sysLog.getCreateTime())) {
            wrapper.ge(SysLog::getCreateTime, sysLog.getCreateTime()[0])
                    .le(SysLog::getCreateTime, sysLog.getCreateTime()[1]);
        }

        return wrapper;
    }
}
